<?php

namespace Bluesquare\Connect\Traits;

trait HasConnectWebhook
{
    public function onConnectCreate(array $data)
    {
        $this->onConnectUpdate($data);
    }

    public function onConnectUpdate(array $data)
    {
        if (in_array(HasConnectData::class, class_uses(self::class))) {
            $this->fillConnectData($data);
        } else {
            $this->email = $data['email'];
        }

        $this->save();

        if (in_array(HasConnectData::class, class_uses(self::class))) {
            $this->postFillConnectData($data);
        }
    }

    public function onConnectDelete(array $data)
    {
        $this->onConnectUpdate($data);

        if (in_array(\Illuminate\Database\Eloquent\SoftDeletes::class, class_uses(self::class))) {
            $this->delete();
        } elseif (array_key_exists('remember_token', $this->attributes)) {
            $this->remember_token = null;
            $this->save();
        }
    }

    public function onConnectRestore(array $data)
    {
        $this->restore();

        $this->onConnectUpdate($data);
    }
}
